#include "BinarySearch.h"
#include <At89LP6440.h>
#include <stdlib.h>
#include <time.h>

void main(void)
{
	short nSizeArray = 0;

	while(nSizeArray < max_size_array)
	{
		short nNumber = GetRandomNumber();

		short nLocation = Search(nNumber, nSizeArray);

		if(nLocation < 0)
		{                
        	short nInsertAt = -(nLocation + 1);

			nSizeArray = Insert(nNumber, nInsertAt, nSizeArray);			    
        }
      
    }
}

// returns a random 16 bit signed integer
short GetRandomNumber()
{
	short nRandonNumber = 0;

	nRandonNumber = rand();
	
	return nRandonNumber;
}

// returns the location of 'Number' or -(location)-1 for where to insert it.
short Search(short Number, short Size)
{
    short nFirst = 0;
    short nLast = Size - 1;

    while (nFirst <= nLast)
    {
        short mid = (nFirst + nLast) / 2;  // compute mid point.
        
        if (Number > RandomNumbers[mid]) 
        {
            nFirst = mid + 1;  // repeat search in top half.
        }
        else if (Number < RandomNumbers[mid]) 
        {
            nLast = mid - 1; // repeat search in bottom half.
        }
        else
            return mid;     // found it. return position
    }

    return - (nFirst + 1);    // failed to find key
}

// insert 'Number' into an array at 'Location' that is sorted in ascending order.
short Insert(short Number, short Location, short Size)
{
	short i = Size;

    while(i > Location)
    {
        RandomNumbers[i] = RandomNumbers[i - 1];
        i--;
    }

    if(i == Location)
    {
        RandomNumbers[i] = Number;
        Size++;
    }

    return Size;
}
